// Generated by CoffeeScript 1.7.1
var child, conditions, each, execute, misc;

each = require('each');

misc = require('./misc');

conditions = require('./misc/conditions');

child = require('./misc/child');

execute = require('./execute');

module.exports = function(goptions, options, callback) {
  var finish, result, _ref;
  _ref = misc.args(arguments, {
    parallel: true
  }), goptions = _ref[0], options = _ref[1], callback = _ref[2];
  result = child();
  finish = function(err, gmodified) {
    if (callback) {
      callback(err, gmodified);
    }
    return result.end(err, gmodified);
  };
  misc.options(options, function(err, options) {
    var gmodified;
    if (err) {
      return finish(err);
    }
    gmodified = 0;
    return each(options).parallel(goptions.parallel).on('item', function(options, next) {
      var do_compare, do_create, do_info, do_modify, info, modified;
      if (!options.name) {
        return next(new Error("Option 'name' is required"));
      }
      if (options.system == null) {
        options.system = false;
      }
      if (options.gid == null) {
        options.gid = null;
      }
      modified = false;
      info = null;
      do_info = function() {
        var _ref1;
        if (typeof options.log === "function") {
          options.log("Get group information for " + options.name);
        }
        if ((_ref1 = options.ssh) != null) {
          _ref1.cache_group = null;
        }
        return misc.ssh.group(options.ssh, function(err, groups) {
          if (err) {
            return next(err);
          }
          if (typeof options.log === "function") {
            options.log("Got " + (JSON.stringify(groups[options.name])));
          }
          info = groups[options.name];
          if (info) {
            return do_compare();
          } else {
            return do_create();
          }
        });
      };
      do_create = function() {
        var cmd;
        cmd = 'groupadd';
        if (options.system) {
          cmd += " -r";
        }
        if (options.gid) {
          cmd += " -g " + options.gid;
        }
        cmd += " " + options.name;
        return execute({
          ssh: options.ssh,
          cmd: cmd,
          log: options.log,
          stdout: options.stdout,
          stderr: options.stderr,
          code_skipped: 9
        }, function(err, created) {
          if (err) {
            return next(err);
          }
          if (created) {
            modified = true;
          } else {
            if (typeof options.log === "function") {
              options.log("Group defined elsewhere than '/etc/group', exit code is 9");
            }
          }
          return next();
        });
      };
      do_compare = function() {
        var k, _i, _len, _ref1;
        _ref1 = ['gid'];
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          k = _ref1[_i];
          if ((options[k] != null) && info[k] !== options[k]) {
            modified = true;
          }
        }
        if (typeof options.log === "function") {
          options.log("Did group information changed: " + modified);
        }
        if (modified) {
          return do_modify();
        } else {
          return next();
        }
      };
      do_modify = function() {
        var cmd;
        cmd = 'groupmod';
        if (options.gid) {
          cmd += " -g " + options.gid;
        }
        cmd += " " + options.name;
        return execute({
          ssh: options.ssh,
          cmd: cmd,
          log: options.log,
          stdout: options.stdout,
          stderr: options.stderr
        }, function(err) {
          return next(err);
        });
      };
      return do_info();
    }).on('both', function(err) {
      return finish(err, gmodified);
    });
  });
  return result;
};
